<?php
//	Original Framework http://theundersigned.net/2006/06/wordpress-how-to-theme-options/ 
//	Updated and added additional options by Jeremy Clark
//	http://clarktech.no-ip.com/
//	Updated and added additional options by Mike Pippin -9/11/2009
//	http://split-visionz.net/2009/wordpress-theme-options-framework-updated/



$themename = "Frostpress";
$shortname = "fp";
$options = array (
	array(	"name" => "Esquema de Cores",
			"desc" => "Escola o esquema de cores pretendido",
			"id" => $shortname."_color",
			"type" => "select",
			"std" => "Grey",
			"options" => array("Grey","Red","Yellow","Green","Teal","Blue","Purple")
	),

	array(	"name" => "Font",
			"desc" => "Escolha a font a ser utilizada",
			"id" => $shortname."_font",
			"type" => "select",
			"std" => "Georgia",
			"options" => array("Verdana","Tahoma","Helvetica","Trebuchet","Georgia")
	),

	array(	"name" => "Tamanho do Texto",
			"desc" => "Escolha o tamanho do texto",
			"id" => $shortname."_fontsize",
			"type" => "select",
			"std" => "13px",
			"options" => array("15px","14px","13px","12px","11px")
	),

	array(	"name" => "Estilho da Barra Lateral",
			"desc" => "Escolha a localização da barra lateral",
			"id" => $shortname."_sidebar",
			"type" => "select",
			"std" => "Right",
			"options" => array("Right","Left","Left and Right","Hidden")
	),

	array(	"name" => "Logótipo",
			"desc" => "Insira a ligação directa para o seu logótipo. O titulo e o slogan do blog são substituidos automáticamente pela a imagem",
			"id" => $shortname."_logo",
			"std" => "",
			"type" => "text"
	),

	array(	"name" => "Posição do Logótipo",
			"desc" => "Escola a posição do logótipo",
			"id" => $shortname."_logopos",
			"type" => "select",
			"std" => "Left",
			"options" => array("Left","Center","Right")
	),

	array(	"name" => "Imagem de Fundo",
			"desc" => "Ligação directa para a imagem de fundo",
			"id" => $shortname."_bgimg",
			"std" => "",
			"type" => "text"
	),

	array(	"name" => "Texto de Subscrição",
			"desc" => "Texto para o link de subscrição (ex: \"Subscreva\")",
			"id" => $shortname."_subscribe",
			"std" => "Subscreva",
			"type" => "text"
	),

	array(	"name" => "Feedburner",
			"desc" => "Se estiver a utilizar o <a href=\"http://feedburner.google.com\" target=\"_blank\">Feedburner</a> coloque aqui o link para o RSS Feed",
			"id" => $shortname."_feedburner",
			"std" => "",
			"type" => "text"
	),

	array(	"name" => "Estilho da Página Inicial",
			"desc" => "Prefere que os artigos na página inicial sejam mostrados completos (full) ou apenas um resumo (excerpt) ?",
			"id" => $shortname."_typeFront",
			"type" => "select",
			"std" => "Full",
			"options" => array("Full","Excerpt")
	),

	array(	"name" => "Estilho da Página de Arquivo",
			"desc" => "Prefere que os artigos na página de arquivo sejam mostrados completos (full) ou apenas um resumo (excerpt) ?",
			"id" => $shortname."_typeArchive",
			"type" => "select",
			"std" => "Excerpt",
			"options" => array("Full","Excerpt")
	),

	array(	"name" => "Ligação para Artigo Seguinte/Anterior",
			"desc" => "Deseja mostrar links para o artigo anterior e seguinte na página single (página do post) ?",
			"id" => $shortname."_postnav",
			"type" => "select",
			"std" => "Yes",
			"options" => array("Yes","No")
	),

	array(	"name" => "Menu do Topo",
			"desc" => "Mostar menu no topo do blogue ?",
			"id" => $shortname."_menu",
			"type" => "select",
			"std" => "Yes",
			"options" => array("Yes","No")
	),

	array(	"name" => "Ligação para a Página Inicial",
			"desc" => "Mostrar o link \"Inicio\" no menu ?",
			"id" => $shortname."_home",
			"type" => "select",
			"std" => "Yes",
			"options" => array("Yes","No")
	),

	array(	"name" => "Autor do Artigo",
			"desc" => "Mostrar o autor dos artigos ?",
			"id" => $shortname."_post_author",
			"type" => "select",
			"std" => "Yes",
			"options" => array("Yes","No")
	),

	array(	"name" => "Separador de Artigos",
			"desc" => "Mostrar uma linha cinzenta entre os artigos ?",
			"id" => $shortname."_separator",
			"type" => "select",
			"std" => "Yes",
			"options" => array("Yes","No")
	),

	array(  "name" => "Rodapé",
	    "desc" => "Insira o texto que deve de aparecer no rodapé (footer) do seu blog.",
            "id" => $shortname."_footer",
            "std" => "",
            "type" => "textarea"
	),

	array(  "name" => "CSS Personalizado",
	    "desc" => "Se pretender adicionar algum css ao seu tema, pode faze-lo colando-o aqui",
            "id" => $shortname."_customcss",
            "std" => "",
            "type" => "textarea"
	)
);

function mytheme_add_admin() {

    global $themename, $shortname, $options;

    if ( $_GET['page'] == basename(__FILE__) ) {
    
        if ( 'save' == $_REQUEST['action'] ) {

                foreach ($options as $value) {
                    update_option( $value['id'], $_REQUEST[ $value['id'] ] ); }

                foreach ($options as $value) {
					if(($value['type'] === "checkbox" or $value['type'] === "multiselect" ) and is_array($_REQUEST[ $value['id'] ])){$_REQUEST[ $value['id'] ]=implode(',',$_REQUEST[ $value['id'] ]);}
                    if( isset( $_REQUEST[ $value['id'] ] ) ) { update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); } else { delete_option( $value['id'] ); } }

                header("Location: themes.php?page=controlpanel.php&saved=true");
                die;

        } else if( 'reset' == $_REQUEST['action'] ) {

            foreach ($options as $value) {
                delete_option( $value['id'] ); 
                update_option( $value['id'], $value['std'] );}

            header("Location: themes.php?page=controlpanel.php&reset=true");
            die;

        }
    }

    add_theme_page($themename." Opções", "Opções", 'edit_themes', basename(__FILE__), 'mytheme_admin');

}

function mytheme_admin() {

    global $themename, $shortname, $options;

    if ( $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' - Configurações Salvas.</strong></p></div>';
    if ( $_REQUEST['reset'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' - Configurações Repostas.</strong></p></div>';
    
?>
<div class="wrap">
<h2>Configurações do Tema <?php echo $themename; ?></h2>

<form method="post">

<table class="optiontable">

<?php foreach ($options as $value) { 
    
if ($value['type'] == "text") { ?>
  <tr valign="top"> 
        <th scope="top" style="text-align:left;"><?php echo $value['name']; ?>:</th>
	<?php if(isset($value['desc'])){?>
	</tr>
	<tr valign="top"> 
		<td style="width:50%; padding-right:10px;"><?php echo $value['desc']?></td>
	<?php } ?>
        <td>
        <input name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_settings( $value['id'] ) != "") { echo stripslashes(get_settings( $value['id'] )); } else { echo stripslashes($value['std']); } ?>" size="40" />
    </td>
</tr>
<tr><td colspan=2><hr /></td></tr>
<?php } elseif ($value['type'] == "select") { ?>
<tr valign="top"> 
        <th scope="top" style="text-align:left;"><?php echo $value['name']; ?>:</th>
	<?php if(isset($value['desc'])){?>
	</tr>
	<tr valign="top"> 
		<td style="width:50%; padding-right:10px;"><?php echo $value['desc']?></td>
	<?php } ?>
        <td>
            <select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
                <?php foreach ($value['options'] as $option) { ?>
                <option<?php if ( get_settings( $value['id'] ) == $option) { echo ' selected="selected"'; }?>><?php echo $option; ?></option>
                <?php } ?>
            </select>
        </td>
    </tr>
<tr><td colspan=2><hr /></td></tr>
<?php } elseif ($value['type'] == "multiselect") { ?>
<tr valign="top"> 
        <th scope="top" style="text-align:left;"><?php echo $value['name']; ?>:</th>
	<?php if(isset($value['desc'])){?>
	</tr>
	<tr valign="top"> 
		<td style="width:50%; padding-right:10px;"><?php echo $value['desc']?></td>
	<?php } ?>
        <td>		
            <select  multiple="multiple" size="3" name="<?php echo $value['id']; ?>[]" id="<?php echo $value['id']; ?>" style="height:50px;">
                <?php $ch_values=explode(',',get_settings( $value['id'] )); foreach ($value['options'] as $option) { ?>
                <option<?php if ( in_array($option,$ch_values)) { echo ' selected="selected"'; }?> value="<?php echo $option; ?>"><?php echo $option; ?></option>
                <?php } ?>
            </select>		
        </td>
    </tr>
<tr><td colspan=2><hr /></td></tr>

<?php } elseif ($value['type'] == "radio") { ?>
<tr valign="top"> 
        <th scope="top" style="text-align:left;"><?php echo $value['name']; ?>:</th>
	<?php if(isset($value['desc'])){?>
	</tr>
	<tr valign="top"> 
		<td style="width:50%; padding-right:10px;"><?php echo $value['desc']?></td>
	<?php } ?>
        <td>
		<?php foreach ($value['options'] as $option) { ?>
			<?php echo $option; ?><input name="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php echo $option; ?>" <?php if ( get_settings( $value['id'] ) == $option) { echo 'checked'; } ?>/>|
		<?php } ?>
        </td>
    </tr>
<tr><td colspan=2><hr /></td></tr>
<?php } elseif ($value['type'] == "textarea") { ?>
<tr valign="top"> 
        <th scope="top" style="text-align:left;"><?php echo $value['name']; ?>:</th>
	<?php if(isset($value['desc'])){?>
	</tr>
	<tr valign="top"> 
		<td style="width:50%; padding-right:10px;"><?php echo $value['desc']?></td>
	<?php } ?>
        <td>
            <textarea name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" cols="40" rows="5"/><?php if ( get_settings( $value['id'] ) != "") { echo stripslashes(get_settings( $value['id'] )); } else { echo stripslashes($value['std']); } ?></textarea>
		</td>
    </tr>
<tr><td colspan=2><hr /></td></tr>

<?php } elseif ($value['type'] == "checkbox") { ?>

    <tr valign="top"> 
        <th scope="top" style="text-align:left;"><?php echo $value['name']; ?>:</th>
	<?php if(isset($value['desc'])){?>
	</tr>
	<tr valign="top"> 
		<td style="width:50%; padding-right:10px;"><?php echo $value['desc']?></td>
	<?php } ?>
        <td>
		<?php 
		$ch_values=explode(',',get_settings( $value['id'] ));
		foreach ($value['options'] as $option) { 
		echo $option; ?><input name="<?php echo $value['id']; ?>[]" type="<?php echo $value['type']; ?>" value="<?php echo $option; ?>" <?php if ( in_array($option,$ch_values)) { echo 'checked'; } ?>/>|
		<?php } ?>

        </td>
    </tr>
<tr><td colspan=2><hr /></td></tr>
<?php } ?>
<?php 
}
?>
</table>
<p class="submit">
<input name="save" type="submit" value="Guardar Opções" />    
<input type="hidden" name="action" value="save" />
</p>
</form>
<form method="post">
<p class="submit">
<input name="reset" type="submit" value="Repor Opções Originais" />
<input type="hidden" name="action" value="reset" />
</p>
</form>
<em>Este tema utiliza uma Framework feita por <a href="http://clark-technet.com/" title="Jeremy Clark">Jeremy Clark</a>. Tema traduzido por <a href="http://www.wptotal.com/" title="Wordpress Themes">Wordpress Total</a>.</em>
<?php
}
add_action('admin_menu', 'mytheme_add_admin'); ?>
